module TIG
    def self.batchpurge()
      puts
      model=Sketchup.active_model
      path=File.expand_path(model.path)
      model.save(path)
      files=[]
      dir=File.dirname(path)
      skps=[]
      Dir.entries(dir).each{|f|
        next unless File.extname(f).downcase==".skp"
        skps << File.expand_path(File.join(dir,f))
      }
      ### by returning to the 1st one we ensure all get processed...
      skps.sort!
      skps << skps[0]
      ###
      temp=nil
      max=skps.length-1
      skps.each_with_index{|skp,i|
        next if not Sketchup.open_file(skp)
        if files[0]
          t,m=files
          File.delete(m) if File.exist?(m)
          File.rename(t,m) if File.exist?(t)
        end
       if i != max
        puts skp
        files=[]
        temp=File.join(dir, "#"+rand.to_s+".skp")
        puts "...Purging..."
        model=Sketchup.active_model
        path=File.expand_path(model.path)
        len=model.definitions.length.to_s
        model.definitions.purge_unused
        puts "Components "+len+" >>> "+model.definitions.length.to_s
        len=model.layers.length.to_s
        model.layers.purge_unused
        puts "Layers "+len+" >>> "+model.layers.length.to_s
        len=model.materials.length.to_s
        model.materials.purge_unused
        puts "Materials "+len+" >>> "+model.materials.length.to_s
        len=model.styles.count.to_s
        model.styles.purge_unused
        puts "Styles "+len+" >>> "+model.styles.count.to_s
        puts path
        puts "...Saving..."
        puts model.save(temp)
        puts
        files << temp << path
       end#if
      }
      ### tidy up - should never be needed!
      File.delete(temp)if temp and File.exist?(temp)
      ###
      UI.beep
      puts "Done."
    end
end